function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { IconFont } from '@zgfe/business-lib';
import { Select, Space, Tooltip } from 'antd';
import _ from 'lodash';
import React, { useEffect, useState } from 'react';
/**
 * 关联ID
 */
var CorrelationId = function CorrelationId(_ref) {
  var className = _ref.className,
    editId = _ref.editId,
    list = _ref.list,
    fieldType = _ref.fieldType,
    value = _ref.value,
    onChange = _ref.onChange;
  var _useState = useState(),
    _useState2 = _slicedToArray(_useState, 2),
    id = _useState2[0],
    setId = _useState2[1];
  var _useState3 = useState(true),
    _useState4 = _slicedToArray(_useState3, 2),
    initing = _useState4[0],
    setIniting = _useState4[1];
  useEffect(function () {
    setId(value);
    setIniting(false);
  }, []);
  useEffect(function () {
    if (onChange) onChange(id);
  }, [id]);
  useEffect(function () {
    if (initing) return;
    setId(undefined);
  }, [fieldType]);
  // 默认不能选择的选项
  var disableList = ['zg_id', 'device_id', 'user_id'];
  var options = list.map(function (item) {
    return _objectSpread(_objectSpread({}, item), {}, {
      showName: item.idAlias || item.idName,
      disabled: fieldType && item.idFieldType !== fieldType || item.id === editId || disableList.includes(item.idName)
    });
  });
  return /*#__PURE__*/React.createElement(Space, null, /*#__PURE__*/React.createElement(Select, {
    options: options,
    value: id,
    disabled: !fieldType,
    fieldNames: {
      label: 'showName',
      value: 'id'
    },
    className: className,
    showSearch: true,
    filterOption: function filterOption(search, option) {
      return new RegExp(_.escapeRegExp(search), 'i').test((option === null || option === void 0 ? void 0 : option.idAlias) || (option === null || option === void 0 ? void 0 : option.idName) || '');
    },
    onChange: setId,
    placeholder: "\u8BF7\u9009\u62E9\u5173\u8054\u5B57\u6BB5",
    suffixIcon: /*#__PURE__*/React.createElement(IconFont, {
      type: "xiangxia",
      className: "cdp-idmapping-create-icon"
    })
  }), /*#__PURE__*/React.createElement(Tooltip, {
    placement: "right",
    overlayInnerStyle: {
      width: '468px'
    },
    title: "\u300C\u5173\u8054ID\u300D\u7684\u4F5C\u7528\uFF1A\u5C06\u65B0\u5F15\u5165\u7684ID\u4E0EID\u5339\u914D\u8868\u4E2D\u7684ID\u5F62\u6210\u8840\u7F18\u5173\u7CFB\uFF0C\r\n\u6BD4\u5982\u60A8\u60F3\u5C06\u624B\u673A\u53F7\u4F5C\u4E3A\u65B0\u7684ID\u5F15\u5165\u5230\u7CFB\u7EDF\u5F53\u4E2D\uFF0C\u90A3\u4E48\u9700\u8981\u901A\u8FC7\u5173\u8054\r\nID\u7684\u914D\u7F6E\u77E5\u9053\u8981\u7ED9\u54EA\u4E2A\u7528\u6237\u6DFB\u52A0\u624B\u673A\u53F7\u3002"
  }, /*#__PURE__*/React.createElement(IconFont, {
    type: "tishiicon",
    className: "cdp-idmapping-create-icon"
  })));
};
export default CorrelationId;